Hi, I want to share my detailed editorial to BGQRS problem from October Long. I used approach which barely fits time limit, but it illustrates a nice useful method that can be used to deal with these kind of query problems. I posted the editorial on my blog (there is a better math syntax available there): Unofficial Editorial: Big Queries from Codechef October Long 2016 I hope you like it :) asked 17 Oct '16, 15:08

The Intended solution was i think uses Segment tree or similar binary data structure. The takeaway from the problem was to learn how two lazy fields propagate down the tree during queries. While propagating a reset update you can ignore the child's previous lazy terms(both), convince yourself here. For propagating "multiplication" update if you encounter a node having reset lazy field then first reset the node from its reset lazy field, mark its child lazy for reset and then do a update query on this node. For doublelazy propagation to work, in my opinion, there should be at least one reset update of some kind, because reset update tells us that we can ignore the child previous lazy terms and set them according to the new update, irrespective of the child node history, as it is a reset update. If you don't have a reset update, then after some queries you will notice that some nodes contain both the lazy terms and you would not be able to distinguish which one to apply first and usually the order in which they are applied would matter and would yield different result, unless you suggest me some two different good operation whose order of application yields the same result(then that would make a good codechef long challenge problem :P) [EDIT] answered 17 Oct '16, 16:00
I tried to solve using same approach. I am getting WA. Please help. :)
(17 Oct '16, 16:15)
there is no need for a boolean(type2, in you code) to tell us whether reset is necessary or not. Notice you can simply set tree[node].st = 1 (for example) to indicate this node doesn't require reset operation. Our solution are two much similar.. hope we don't find ourself in plagiarism :P (LOL). couldn't find the bug Yet.
(17 Oct '16, 17:27)

Nice. Though Sqrt Decomposition is viable here, I have an alternative solution using Lazy Propogation on Segment Tree. The only "hard" query here is the second one. However, if you store :
answered 17 Oct '16, 15:45
Sure, also noticing that the second query can be transformed to first assigning sequence 1,2,.. and then multiply it by Y can help a lot while handing that query. Lazy Propagation is something closer to the intended solution. Using sqrt blocks was too tempting for me, so I went for it  I see that we have similar run times, did you need to optimize your solution?
(17 Oct '16, 15:54)
you sure the largest ?
(17 Oct '16, 16:02)
2
@pkacprzak My solution passed without fastio too, but fastio is slightly faster.
(17 Oct '16, 16:11)

Here is my solution which uses single segment tree. It uses oops to further simplify the problem.Solution link answered 23 Oct '16, 00:31

Answer is hidden as author is suspended. Click here to view.
answered 23 Oct '16, 01:12

Nice editorial or I would say article. I have added my editorial/explanation to the same problem. The Update and Query range complexity for my solution is O(ln(N)). It runs in .77 seconds in java. You can see the same in my solution. answered 17 Oct '16, 15:16

I have tried to implement the Lazy Propagation on a Segment Tree to fetch the queries and update the values in O(logN). But my solution wasn't accepted. Can someone help me out with where am I going wrong? PS: My code gives the correct output for the given test case and some random test cases. Here is my code. answered 17 Oct '16, 18:21
8
As your solution is too lengthy I can not read it completely but the thing is that your propagation of updates is not correct , for the test case your codes output is "6" but it should be "2" so simulate your codes working on this test case and you will know the mistake.
(22 Oct '16, 13:22)

Sqrt Decomposition is a nice trick and can help to solve many problems. Thanks for sharing!!
Can you suggest some good problems to start mastering this trick?
@ankurverma1994 I added one bonus problem at the bottom of the editorial. It is perhaps the most classical one you can get.
And Why did you choose KMax as 20? Thanks
@vishveshcoder As you can see, I set K (the initial size of a block) to be max(20, sqrt(n)). The constant 20 is chosen arbitrary. I did it in order to avoid extremely small blocks when sqrt(n) is small. Notice that later I set num_of_blocks = N / K. However, I think that you can just write K = sqrt(n) and everything should work just fine.